// ChkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ChkRes.h"

#include <dlgs.h>
#include <direct.h>

#include "ChkDlg.h"
#include "ChoosDir.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheckResDlg dialog

CCheckResDlg::CCheckResDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCheckResDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCheckResDlg)
	m_strDirectory = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bRunning = FALSE;
	m_bCancel = FALSE;
}

void CCheckResDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCheckResDlg)
	DDX_Control(pDX, IDC_TRACE, m_Trace);
	DDX_Text(pDX, IDC_DIRECTORY, m_strDirectory);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCheckResDlg, CDialog)
	//{{AFX_MSG_MAP(CCheckResDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDSTART, OnStart)
	ON_BN_CLICKED(IDBROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheckResDlg message handlers

BOOL CCheckResDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	char buffer[_MAX_FNAME+1];
	_getcwd(buffer, _MAX_FNAME);
	m_strDirectory = buffer;
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCheckResDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	switch (nID & 0xFFF0)
	{
	  case IDM_ABOUTBOX:
	  {
	    CAboutDlg dlgAbout;
	    dlgAbout.DoModal();
	    break;
	  }
	  case SC_CLOSE:
	  {
	    if (m_bRunning)
	    {
	      m_bCancel = TRUE;
	      break;
	    }
	  }
	  default:
	  {
	    CDialog::OnSysCommand(nID, lParam);
	  }
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCheckResDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCheckResDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCheckResDlg::OnBrowse() 
{
  if (m_bRunning) return;

  DWORD	flags = 0;
  BOOL bLongNames = TRUE;

  if (bLongNames)
    flags |= (OFN_SHOWHELP | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_ENABLETEMPLATE);
  else
    flags |= (OFN_SHOWHELP | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_ENABLETEMPLATE | OFN_NOLONGNAMES);
	
  CChooseDir dlg(TRUE, NULL, NULL, flags, NULL);
  dlg.m_ofn.lpstrInitialDir = m_strDirectory;
  if (dlg.DoModal() == IDOK)
  {
    WORD wFileOffset;
    wFileOffset = dlg.m_ofn.nFileOffset;
    dlg.m_ofn.lpstrFile[wFileOffset-1] = '\0';
    CString strDirectory = dlg.m_ofn.lpstrFile;
    m_strDirectory = strDirectory;
    UpdateData(FALSE);
  }
}

void CCheckResDlg::Clear()
{
  m_Trace.SetWindowText(NULL);
}

void CCheckResDlg::Trace(LPCSTR Message)
{
  m_Trace.SetSel(-1, -1, NULL);
  m_Trace.ReplaceSel(Message);
  m_Trace.ReplaceSel("\r\n");
}

/////////////////////////////////////////////////////////////////////////////
// remark: the folowing code is not optimized.

#define BSIZE 512

#define DEFINE_SIZE 1000
typedef struct { char* String; unsigned int Val; BOOL bStatus; } DEFINE;

#define MAX_PREFIX 10

#define START_RESOURCE 0
#define END_RESOURCE   4
#define START_STRING   5
#define END_STRING     6
#define START_CONTROL  7
#define START_COMMAND  8
#define START_IDW      9

char *Prefix[MAX_PREFIX] =
{
  "IDR_",
  "IDB_",
  "IDI_",
  "IDD_",
  "IDM_",
  "IDS_",
  "IDP_",
  "IDC_",
  "ID_",
  "IDW_",
};

#define MAX_FILETYPE 3
char *FileType[MAX_FILETYPE] =
{
  "*.h",    // not move, assert *.h at position zero
  "*.cpp",
  "*.rc",
};

static char *szResourceFile = "resource.h";

unsigned int nSymed    = {   101 };
unsigned int nControl  = {  1001 };
unsigned int nCommand  = { 32771 };
unsigned int nResource = {   101 };

int xtoi(LPCSTR lpszString)
{
  return (int)strtol(lpszString, NULL, 16);
}

BOOL chkpfx(const char *Buffer, const char *Prefix)
{
  if (!memcmp(Buffer, Prefix, strlen(Prefix))) return TRUE;
  return FALSE;
}

char *GetSubPfx(char *String)
{
  static char Buffer[BSIZE];
  strcpy(Buffer, String);
  char *p1 = strchr(Buffer, '_');
  if (p1) p1++; else return NULL;
  char *p2 = strchr(p1, '_');
  if (p2) *p2 = '\0'; else return NULL;
  return p1;
}

#define SORTFCT int (__cdecl *)(const void *,const void *)
int CompareDefine(DEFINE *pDef1, DEFINE *pDef2)
{
  // first ID without '_'
  if (!strchr(pDef1->String, '_'))
  {
    if (!strchr(pDef2->String, '_'))
      return strcmp(pDef1->String, pDef2->String);
    return -1;
  }
  if (!strchr(pDef2->String, '_'))
  {
    if (!strchr(pDef1->String, '_'))
      return strcmp(pDef1->String, pDef2->String);
    return  1;
  }

  // next extract IDR_MAINFRAME as first IDR_
  if (!strcmp(pDef1->String, "IDR_MAINFRAME")) return -1;
  if (!strcmp(pDef2->String, "IDR_MAINFRAME")) return  1;
  
  // next ID?_
  for (int i = 0; i < MAX_PREFIX; i++)
  {
    BOOL bPfx1 = chkpfx(pDef1->String, Prefix[i]);
    BOOL bPfx2 = chkpfx(pDef2->String, Prefix[i]);
    
    char *pSubPfx1 = GetSubPfx(pDef1->String);
    char *pSubPfx2 = GetSubPfx(pDef2->String);

    // if a valid prefix
    if (bPfx1 || bPfx2)
    {
      // first IDs with no sub-prefix
      if (bPfx1 && bPfx2 && !pSubPfx1 && !pSubPfx2)
	return strcmp(pDef1->String, pDef2->String);
      
      if (!bPfx1) return  1;
      if (!bPfx2) return -1;

      return strcmp(pDef1->String, pDef2->String);
    }
  }
  return strcmp(pDef1->String, pDef2->String);
}

void CCheckResDlg::PumpMessage()
{
  CWinThread* pThread = AfxGetThread();
  while (TRUE)
  {
    MSG msg;
    if (::PeekMessage(&msg, NULL, NULL, NULL, PM_NOREMOVE))
      pThread->PumpMessage();
    else
    {
      pThread->OnIdle(-1);
      break;
    }
  }
}

void CCheckResDlg::OnStart()
{
  if (m_bRunning) return;

  int i, j, k;
  CStdioFile File;
  static char Buffer[BSIZE];
  static char SubStr[BSIZE];
  static char LastPfx[BSIZE];
  static char LastSubPfx[BSIZE];
  static char AppName[64];

  CWaitCursor cursorWait;
  m_bRunning = TRUE;
  m_bCancel = FALSE;
  CButton *pButton = (CButton*)GetDlgItem(IDCANCEL);
  pButton->SetWindowText("Cancel");

  int nDef = 0;
  CArray <DEFINE, DEFINE&> Define;
  Define.SetSize(DEFINE_SIZE, DEFINE_SIZE);

  // use a CListBox for directory contents
  CListBox FileList;
  FileList.Create(WS_DISABLED, CRect(0, 0, 0, 0), this, NULL);

  Clear();

  unsigned int nSym = nSymed;
  unsigned int nCtl = nControl;
  unsigned int nCmd = nCommand;
  unsigned int nRes = nResource;

  unsigned int nStd = 8;

  // first parse resource.h file
  Trace("resource.h");
  if (File.Open(szResourceFile, CFile::modeRead | CFile::typeText))
  {
    while (File.ReadString(Buffer, BSIZE))
    {
      PumpMessage(); if (m_bCancel) goto Exit;

      char *p, *d;

      // get application name from resource.h file
      p = strstr(Buffer, "Used by ");
      if (p)
      {
	p += 8;
	d = AppName;
	while (*p && *p > ' ') *d++ = *p++;
	*d = '\0';
      }
      
      // search #define
      p = strstr(Buffer, "#define");
      if (p)
      {
	p += 7;
	d = SubStr;
	while (*p && !isalnum(*p) && *p != '_') p++;
	if (*p)
	{
	  while (isalnum(*p) || *p == '_') { *d++ = *p++; }
	  *d = '\0';

	  // if not exist, add this substring to define array
	  for (i = 0; i < nDef; i++)
	    if (strcmp(SubStr, Define[i].String) == 0) break;
	  
	  if (i == nDef)
	  {
	    DEFINE Def;

	    Def.String = new char[strlen(SubStr)+1];
	    strcpy(Def.String, SubStr);
	    while (*p && !isdigit(*p)) p++;
	    if (*p && (*(p+1) == 'x' || *(p+1) == 'X'))
	      Def.Val = xtoi(p);
	    else
	      Def.Val = atoi(p);
	    Def.bStatus = FALSE;
	    Define.SetAtGrow(nDef++, Def);
	  }
	}
      }
    }
    File.Close();
  }
  Trace("");

  // sort define array by ID
  qsort(Define.GetData(), nDef, sizeof(DEFINE), (SORTFCT)CompareDefine);
  
  // find resources in files
  for (i = 0; i < MAX_FILETYPE; i++)
  {
    FileList.ResetContent();
    CString strPathName = m_strDirectory + "\\" + FileType[i];
    int ret = FileList.Dir(0x0000, strPathName);
    if (ret != LB_ERR)
    {
      int Count = FileList.GetCount();
      for (j = 0; j < Count; j++)
      {
	char FileName[_MAX_FNAME+1];
	FileList.GetText(j, FileName);
	if (i == 0 && strstr(strlwr(FileName), szResourceFile)) continue;
	
	Trace(FileName);

	// open file
	if (File.Open(FileName, CFile::modeRead | CFile::typeText))
	{
	  while (File.ReadString(Buffer, BSIZE))
	  {
	    PumpMessage(); if (m_bCancel) goto Exit;
	    for (k = 0; k < nDef; k++)
	      if (strstr(Buffer, Define[k].String))
		Define[k].bStatus = TRUE;
	  }
	  File.Close();
	}
      }
    }
    Trace("");
  }
  
  // first renum ID without '_'
  for (i = 0; i < nDef; i++)
  {
    PumpMessage(); if (m_bCancel) goto Exit;
    if (!Define[i].bStatus) continue;
    if (strchr(Define[i].String, '_')) break;
    Define[i].Val = nStd++;
  }
  
  // check resource start
  if (nRes < nStd) nRes = nStd;

  // renum resources IDR, IDB, IDI, IDD, IDM with sub-prefix
  for (i = 0; i < nDef; i++)
  {
    PumpMessage(); if (m_bCancel) goto Exit;
    if (!Define[i].bStatus) continue;
    for (j = START_RESOURCE; j <= END_RESOURCE; j++)
      if (chkpfx(Define[i].String, Prefix[j]))
	Define[i].Val = nRes++;
  }

  // start string on next hundred
  nRes = ((nRes / 100) + 1) * 100;

  // renum strings IDS with sub-prefix like IDS_ERR_
  strcpy(LastSubPfx, "");
  for (i = 0; i < nDef; i++)
  {
    PumpMessage(); if (m_bCancel) goto Exit;
    if (!Define[i].bStatus) continue;
    for (j = START_STRING; j <= END_STRING; j++)
    {
      if (chkpfx(Define[i].String, Prefix[j]))
      {
	// extract sub-prefix
	char *SubPfx = GetSubPfx(Define[i].String);
	
	// if new sub-prefix, align on page
	if (SubPfx)
	{
	  if (strcmp(LastSubPfx, SubPfx) != 0)
	    nRes = ((nRes + 15) / 16) * 16;
	  strcpy(LastSubPfx, SubPfx);
	} else strcpy(LastSubPfx, "");
	Define[i].Val = nRes++;
      }
    }
  }

  // check control start on next thousand
  if (nCtl < nRes) nCtl = ((nCtl / 1000) + 1) * 1000;

  // renum controls IDC
  for (i = 0; i < nDef; i++)
  {
    PumpMessage(); if (m_bCancel) goto Exit;
    if (!Define[i].bStatus) continue;
    if (chkpfx(Define[i].String, Prefix[START_CONTROL]))
      Define[i].Val = nCtl++;
  }
  
  // renum commands ID_
  for (i = 0; i < nDef; i++)
  {
    PumpMessage(); if (m_bCancel) goto Exit;
    if (!Define[i].bStatus) continue;
    if (chkpfx(Define[i].String, Prefix[START_COMMAND]))
      Define[i].Val = nCmd++;
  }

  // create new resource file resource.new
  Trace("writing resource.new");
  if (nDef)
  {
    if (File.Open("resource.new", CFile::modeWrite | CFile::modeCreate | CFile::typeText))
    {
      File.WriteString("//{{NO_DEPENDENCIES}}\n");
      File.WriteString("// Microsoft Developer Studio generated include file.\n");
      sprintf(Buffer, "// Used by %s\n", AppName);
      File.WriteString(Buffer);
      File.WriteString("//\n");
      for (i = 0; i < nDef; i++)
      {
	if (!Define[i].bStatus) continue;

	// do not write beginning with _APS_NEXT_
	if (chkpfx(Define[i].String, "_APS_NEXT_")) continue;
	  
	// special case for IDW
	if (chkpfx(Define[i].String, Prefix[START_IDW]))
	  sprintf(Buffer, "#define %s 0x%X\n", Define[i].String, Define[i].Val);
	else
	  sprintf(Buffer, "#define %s %u\n", Define[i].String, Define[i].Val);
	File.WriteString(Buffer);

	// check for reserved 0 <= ID <= 7
	if (Define[i].Val <= 7)
	{
	  sprintf(Buffer, "warning: %s %u", Define[i].String, Define[i].Val);
	  Trace(Buffer);
	}

	// check for resources 1 <= ID <= 0x6fff
	for (j = START_RESOURCE; j <= END_RESOURCE; j++)
	{
	  if (chkpfx(Define[i].String, Prefix[j]) && Define[i].Val > 0x6fff)
	  {
	    sprintf(Buffer, "warning: %s %u", Define[i].String, Define[i].Val);
	    Trace(Buffer);
	  }
	}
	  
	// check for strings 1 <= ID <= 0x7fff
	for (j = START_STRING; j <= END_STRING; j++)
	{
	  if (chkpfx(Define[i].String, Prefix[j]) && Define[i].Val > 0x7fff)
	  {
	    sprintf(Buffer, "warning: %s %u", Define[i].String, Define[i].Val);
	    Trace(Buffer);
	  }
	}
	  
	// check for controls 8 <= ID <= 0xdfff
	if (chkpfx(Define[i].String, Prefix[START_CONTROL]) && Define[i].Val > 0xdfff)
	{
	  sprintf(Buffer, "warning: %s %u", Define[i].String, Define[i].Val);
	  Trace(Buffer);
	}
	  
	// check for commands 0x8000 <= ID <= 0xdfff
	if (chkpfx(Define[i].String, Prefix[START_COMMAND]) &&
	  (Define[i].Val < 0x8000 || Define[i].Val > 0xdfff))
	{
	  sprintf(Buffer, "warning: %s %u", Define[i].String, Define[i].Val);
	  Trace(Buffer);
	}
      }
      File.WriteString("\n");
      File.WriteString("// Next default values for new objects\n");
      File.WriteString("//\n");
      File.WriteString("#ifdef APSTUDIO_INVOKED\n");
      File.WriteString("#ifndef APSTUDIO_READONLY_SYMBOLS\n");
      sprintf(Buffer, "#define _APS_NEXT_RESOURCE_VALUE %u\n", nRes);
      File.WriteString(Buffer);
      sprintf(Buffer, "#define _APS_NEXT_COMMAND_VALUE %u\n", nCmd);
      File.WriteString(Buffer);
      sprintf(Buffer, "#define _APS_NEXT_CONTROL_VALUE %u\n", nCtl);
      File.WriteString(Buffer);
      sprintf(Buffer, "#define _APS_NEXT_SYMED_VALUE %u\n", nSym);
      File.WriteString(Buffer);
      File.WriteString("#endif\n");
      File.WriteString("#endif\n");

      File.Close();
    }
  }

  // clean up
  for (i = 0; i < nDef; i++)
    delete [] Define[i].String;

  Trace("");
  Trace("copy resource.new into resource.h");
  Trace("and rebuild your project");
  m_bRunning = FALSE;
  pButton->SetWindowText("Exit");
  return;

Exit:
  Trace("");
  Trace("execution canceled");
  m_bRunning = FALSE;
  pButton->SetWindowText("Exit");
}

void CCheckResDlg::OnCancel() 
{
  if (m_bRunning) m_bCancel = TRUE;
  else CDialog::OnCancel();
}
